summaryrefslogtreecommitdiffstats
path: root/tests/id/setgid.sh
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-27 17:39:29 +0000
committerDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-27 17:39:29 +0000
commit8ffec2a3aba6f114784e11f89ef1d57a096ae540 (patch)
treeccebcbad06203e8241a8e7249f8e6c478a3682ea /tests/id/setgid.sh
parentInitial commit. (diff)
downloadcoreutils-upstream.tar.xz
coreutils-upstream.zip
Adding upstream version 8.32.upstream/8.32upstream
Signed-off-by: Daniel Baumann <daniel.baumann@progress-linux.org>
Diffstat (limited to 'tests/id/setgid.sh')
-rwxr-xr-xtests/id/setgid.sh47
1 files changed, 47 insertions, 0 deletions
diff --git a/tests/id/setgid.sh b/tests/id/setgid.sh
new file mode 100755
index 0000000..dc793d1
--- /dev/null
+++ b/tests/id/setgid.sh
@@ -0,0 +1,47 @@
+#!/bin/sh
+# Verify that id [-G] prints the right group when run set-GID.
+
+# Copyright (C) 2012-2020 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ id
+require_root_
+
+getlimits_
+
+# Construct a different group number
+gp1=$NON_ROOT_GID
+gp1=$(expr $gp1 + 1) ||
+ skip_ "failed to adjust GID $NON_ROOT_GID"
+
+test "$gp1" -lt $GID_T_MAX ||
+ skip_ "GID $gp1 is reserved on some systems"
+
+echo $gp1 > exp || framework_failure_
+
+# With coreutils-8.16 and earlier, id -G would print both:
+# $gp1 $NON_ROOT_GID
+chroot --skip-chdir --user=$NON_ROOT_USERNAME:+$gp1 --groups='' / \
+ env PATH="$PATH" id -G > out || fail=1
+compare exp out || fail=1
+
+# With coreutils-8.22 and earlier, id would erroneously print
+# groups=$NON_ROOT_GID
+chroot --skip-chdir --user=$NON_ROOT_USERNAME:+$gp1 --groups='' / \
+ env PATH="$PATH" id > out || fail=1
+grep -F "groups=$gp1" out || { cat out; fail=1; }
+
+Exit $fail